# Tidings
[![Build Status](https://travis-ci.org/nitin42/Tidings.svg?branch=master)](https://travis-ci.org/nitin42/Tidings)

> A NLP based news application powered by [API.ai](api.ai)

<br/><br/><br/>![](https://github.com/nitin42/Tidings/blob/master/working.gif)

<br/>

Tidings is a NLP based news applications that extracts the intents and entities from the user's request and uses this extracted context to fetch the content for the user.

## Current status

You can check the app [here](http://tidings.netlify.com/). Its currently in development but I am repeatedly updating and fixing the issues. The target is to complete all the below mention goals and to finally deploy the production ready build.

## Goals
- [ ] Server side rendering
- [x] Write tests
- [ ] real-time updates
- [ ] Offline-first

## Powered by

* [API.ai]()
* [React]()
* [Redux]()
* [Bulma.io]()
* [styled-components]()
* [react-progressive-image]()
* [Webpack]()

## Why Tidings?

Tidings declarative approach makes it easy to search the articles on the web. 

For eg - 

> ***I want some articles on sports***

> ***Latest articles on football***

> ***Some articles from TheVerge***
 
> ***What's new on the Techcrunch!***

Refer to [this](https://github.com/nitin42/Tidings/blob/master/Usage.md) guide more info.


## Contributing

#### Ideas for Improvements

Contributions are appreciated. Here are some ideas to improve the app further.

* Find or fix bugs
* Suggest UI changes 
* Request for a new category for news
* Issues regarding the fulfilment of a request
* Add tests

## License
ISC

